﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="index.aspx.cs" Inherits="Gwbnsh.Web.api.payment.wxh5pay.index" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>微信H5支付</title>
    <meta http-equiv="content-type" content="text/html;image/gif;charset=utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <link rel="stylesheet" type="text/css" href="http://static.gwbnsh.net.cn/webapp/css/base.css" />
    <link rel="stylesheet" type="text/css" href="http://static.gwbnsh.net.cn/webapp/css/core.css" />
    <link rel="icon" href="http://static.gwbnsh.net.cn/favicon.ico" type="image/x-icon" />
    <script type="text/javascript" charset="utf-8" src="../../../scripts/jquery/jquery-1.11.2.min.js"></script>
    <script type="text/javascript">
        $(function () {
            sendPost(); //调用监听事件
        });
        //监听订单支付状态
        function sendPost() {
            //发送AJAX请求
            $.ajax({
                url: "return_url.aspx",
                type: "POST",
                timeout: 30000,
                data: { "order_no": "<%=order_no%>" },
                dataType: "json",
                success: function (data, type) {
                    if (data.status == 1) {
                        setTimeout(function () {
                            location.href = data.url; //支付成功后跳转
                        }, 1000);
                    } else {
                        time();
                    }
                }
            });
        }
        function time() {
            setTimeout(function () {
                sendPost();
            }, 5000);
        }
    </script>
    <style type="text/css">
        /* 重置 [[*/
        body, p, ul, li, h1, h2, form, input {
            margin: 0;
            padding: 0;
        }

        h1, h2 {
            font-size: 100%;
        }

        ul {
            list-style: none;
        }

        body {
            -webkit-user-select: none;
            -webkit-text-size-adjust: none;
            font-family: Helvetica;
            background: #ECECEC;
        }

        html, body {
            height: 100%;
        }

        a, button, input, img {
            -webkit-touch-callout: none;
            outline: none;
        }

        a {
            text-decoration: none;
        }
        /* 重置 ]]*/
        /* 功能 [[*/
        .hide {
            display: none !important;
        }

        .cf:after {
            content: ".";
            display: block;
            height: 0;
            clear: both;
            visibility: hidden;
        }
        /* 功能 ]]*/
        /* 按钮 [[*/
        a[class*="btn"] {
            display: block;
            height: 42px;
            line-height: 42px;
            color: #FFFFFF;
            text-align: center;
            border-radius: 5px;
        }

        .btn-blue {
            background: #3D87C3;
            border: 1px solid #1C5E93;
        }

        .btn-green {
            background-image: -webkit-gradient(linear, left top, left bottom, color-stop(0, #43C750), color-stop(1, #31AB40));
            border: 1px solid #2E993C;
            box-shadow: 0 1px 0 0 #69D273 inset;
        }
        /* 按钮 [[*/
        /* 充值页 [[*/
        .charge {
            font-family: Helvetica;
            padding-bottom: 10px;
            -webkit-user-select: none;
        }

            .charge h1 {
                height: 44px;
                line-height: 44px;
                color: #FFFFFF;
                background: #3D87C3;
                text-align: center;
                font-size: 20px;
                -webkit-box-sizing: border-box;
                box-sizing: border-box;
            }

            .charge h2 {
                font-size: 14px;
                color: #777777;
                margin: 5px 0;
                text-align: center;
            }

            .charge .content {
                padding: 10px 12px;
            }

            .charge .select li {
                position: relative;
                display: block;
                float: left;
                width: 100%;
                margin-right: 2%;
                height: 150px;
                line-height: 150px;
                text-align: center;
                border: 1px solid #BBBBBB;
                color: #666666;
                font-size: 16px;
                margin-bottom: 5px;
                border-radius: 3px;
                background-color: #FFFFFF;
                -webkit-box-sizing: border-box;
                box-sizing: border-box;
                overflow: hidden;
            }

            .charge .price {
                border-bottom: 1px dashed #C9C9C9;
                padding: 10px 10px 15px;
                margin-bottom: 20px;
                color: #666666;
                font-size: 12px;
            }

                .charge .price strong {
                    font-weight: normal;
                    color: #EE6209;
                    font-size: 26px;
                    font-family: Helvetica;
                }

            .charge .showaddr {
                border: 1px dashed #C9C9C9;
                padding: 10px 10px 15px;
                margin-bottom: 20px;
                color: #666666;
                font-size: 12px;
                text-align: center;
            }

                .charge .showaddr strong {
                    font-weight: normal;
                    color: #9900FF;
                    font-size: 26px;
                    font-family: Helvetica;
                }

            .charge .copy-right {
                margin: 5px 0;
                font-size: 12px;
                color: #848484;
                text-align: center;
            }
        /* 充值页 ]]*/
    </style>
</head>
<body>
    <article class="charge">
        <h1>微信支付</h1>
        <section class="content">
            <h2>商品：<%=subject %>。</h2>
            <ul class="select cf">
            </ul>
            <div class="price">支付金额：<strong>￥<%=order_amount %>元</strong></div>
            <div class="operation"><a class="btn-green" id="getBrandWCPayRequest" href="<%=mweb_url %>"">立即付款</a></div>
        </section>
    </article>
</body>
<script src="//wx.gtimg.com/wxpay_h5/fingerprint2.min.1.4.1.js"></script>
<script type="text/javascript" src="../../css/zepto.min.js"></script>
</html>
