﻿using Gwbnsh.API.Payment.wxpay;
using Gwbnsh.Common;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text.RegularExpressions;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace Gwbnsh.Web.api.payment.wxh5pay
{
    public partial class index : System.Web.UI.Page
    {
        protected string order_no = string.Empty;
        protected decimal order_amount = decimal.Parse("0");
        protected string subject = string.Empty;
        protected string mweb_url = string.Empty;
        protected void Page_Load(object sender, EventArgs e)
        {
            //读取站点配置信息
            Model.sysconfig sysConfig = new BLL.sysconfig().loadConfig();
            int site_payment_id = 0; //订单支付方式

            //=============================获得订单信息================================
            order_no = Request.QueryString["pay_order_no"] as string;
            order_amount = decimal.Parse(Request.QueryString["pay_order_amount"] == null ? "0" : Request.QueryString["pay_order_amount"]);
            string user_name = Request.QueryString["pay_user_name"] as string;
            subject = Request.QueryString["pay_subject"] as string;
            //检查参数是否正确
            if (string.IsNullOrEmpty(order_no) || order_amount == 0)
            {
                string errMsg = "对不起，您提交的参数有误！";
                Response.Write("<script>alert('" + errMsg + "');window.location.href='http://m.gwbnsh.net.cn/hd/SellPhone/mgood_list.aspx'</script>");
                return;
            }
            //===============================判断订单==================================
            if (order_no.StartsWith("R")) //R开头为在线充值订单
            {
                Model.user_recharge model = new BLL.user_recharge().GetModel(order_no);
                if (model == null)
                {
                    Response.Redirect(new Web.UI.BasePage().linkurl("error", "?msg=" + Utils.UrlEncode("对不起，您充值的订单号不存在或已删除！")));
                    return;
                }
                if (model.amount != order_amount)
                {
                    Response.Redirect(new Web.UI.BasePage().linkurl("error", "?msg=" + Utils.UrlEncode("对不起，您充值的订单金额与实际金额不一致！")));
                    return;
                }
                if (model.status == 1)
                {
                    Response.Redirect(new Web.UI.BasePage().linkurl("payment", "?action=succeed&order_no=" + order_no));
                    return;
                }
                site_payment_id = model.payment_id; //站点支付方式ID
            }
            else //B开头为商品订单
            {
                Model.orders model = new BLL.orders().GetModel(order_no);
                if (model == null)
                {
                    string errMsg = "对不起，您充值的订单号不存在或已删除！";
                    Response.Write("<script>alert('" + errMsg + "');window.location.href='http://m.gwbnsh.net.cn/hd/SellPhone/mgood_list.aspx'</script>");
                    return;
                }
                if (model.order_amount != order_amount)
                {
                    string errMsg = "对不起，您支付的订单金额与实际金额不一致！";
                    Response.Write("<script>alert('" + errMsg + "');window.location.href='http://m.gwbnsh.net.cn/hd/SellPhone/mgood_list.aspx'</script>");
                    return;
                }
                if (model.payment_status == 2)
                {
                    Response.Redirect("http://www.gwbnsh.net.cn/hd/SellPhone/sucess.aspx?order_no=" + order_no);
                    return;
                }
                site_payment_id = model.payment_id; //站点支付方式ID
            }
            if (user_name != "")
            {
                //user_name =  user_name;
            }
            else
            {
                //user_name = "匿名用户";
            }

            //===========================调用统一下单接口==============================
            string sendUrl = "https://api.mch.weixin.qq.com/pay/unifiedorder";
            H5Config h5Config = new H5Config(site_payment_id);
            WxPayData data = new WxPayData();
            data.SetValue("body", subject); //商品描述
            data.SetValue("detail",user_name); //商品详情
            data.SetValue("out_trade_no", order_no); //商户订单号
            data.SetValue("total_fee", (Convert.ToDouble(order_amount) * 100).ToString()); //订单总金额,以分为单位
            data.SetValue("trade_type", "MWEB");//交易类型
            data.SetValue("product_id", order_no);//商品ID
            data.SetValue("notify_url", h5Config.Notify_url); //异步通知url
            data.SetValue("spbill_create_ip", DTRequest.GetIP()); //终端IP
            data.SetValue("appid", h5Config.AppId); //公众账号ID
            data.SetValue("mch_id", h5Config.Partner); //商户号
            data.SetValue("nonce_str", H5Pay.GenerateNonceStr()); //随机字符串
            data.SetValue("scene_info", "{\"h5_info\": {\"type\":\"wap\",\"wap_url\": \"http://m.gwbnsh.net.cn\",\"wap_name\": \"上海长城宽带\"}} "); //场景信息
            data.SetValue("sign", data.MakeSign(h5Config.Key)); //签名
            string xml = data.ToXml(); //转换成XML
            var startTime = DateTime.Now; //开始时间
            string response = HttpService.Post(xml, sendUrl, false, 6); //发送请求
            var endTime = DateTime.Now; //结束时间
            int timeCost = (int)((endTime - startTime).TotalMilliseconds); //计算所用时间
            WxPayData result = new WxPayData();
            result.FromXml(response, h5Config.Key);
            H5Pay.ReportCostTime(site_payment_id, sendUrl, timeCost, result); //测速上报

            mweb_url = result.GetValue("mweb_url").ToString();//mweb_url为拉起微信支付收银台的中间页面，可通过访问该url来拉起微信客户端，完成支付,mweb_url的有效期为5分钟。
        }
    }
}